=== debian/changelog ===
qmapshack (1.15.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.1, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 07 Dec 2020 17:35:29 +0100

qmapshack (1.15.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches applied/included upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 27 Nov 2020 08:51:18 +0100

qmapshack (1.15.0-2) unstable; urgency=medium

  * Bump watch file version to 4.
  * Add upstream patch to fix FTBFS with Qt 5.15.
  * Add upstream patch to fix wrong timestamp when loading FIT.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 16 Nov 2020 11:34:35 +0100
